#include "CommandOps.h"
#include <stdio.h>

RS_BEGIN_NAMESPACE

/****************************************
 * Operation for binary float addition  *
 ****************************************/

std::vector<opType> OpKick::getArgumentTypes()
{
  std::vector<opType> aTypes;
  aTypes.insert(aTypes.end(), opFloat);
  aTypes.insert(aTypes.end(), opFloat);
  return aTypes;
}

std::string OpKick::getString()
{
  if(arguments.size() >= 2)
    {
      char buf[256];
      snprintf(buf, 256, "kick %f %f", arguments[0]->getFloat(), arguments[1]->getFloat());
      return buf;
    }
  return "kick 0 0";
}

std::string OpKick::getOperationString()
{
  return "cmdkick";
}

/*******************************************
 * Operation for binary float subtraction  *
 *******************************************/

std::vector<opType> OpDash::getArgumentTypes()
{
  std::vector<opType> aTypes;
  aTypes.insert(aTypes.end(), opFloat);
  return aTypes;
}

std::string OpDash::getString()
{
  if(arguments.size() >= 1)
    {
      char buf[256];
      snprintf(buf, 256, "dash %f", arguments[0]->getFloat());
      return buf;
    } 
  return "dash 0";
}

std::string OpDash::getOperationString()
{
  return "cmddash";
}

/**********************************************
 * Operation for binary float multiplication  *
 **********************************************/

std::vector<opType> OpTurn::getArgumentTypes()
{
  std::vector<opType> aTypes;
  aTypes.insert(aTypes.begin(), opFloat);
  return aTypes;
}

std::string OpTurn::getString()
{
  if(arguments.size() >= 1)
    {
      char buf[256];
      snprintf(buf, 256, "turn %f", arguments[0]->getFloat());
      return buf;
    } 
  return "turn 0";
}

std::string OpTurn::getOperationString()
{
  return "cmdturn";
}

RS_END_NAMESPACE









