#ifndef _CONTROLOPS_H_
#define _CONTROLOPS_H_


#include "Operation.h"

RS_BEGIN_NAMESPACE

/****************************************
 * Operation for representing kicks     *
 ****************************************/
class OpStringIf : public StringOperation {
public:
  virtual Operation* clone() { return cloneOperation(this); }
  // Theese need to be overridden
   virtual std::vector<opType> getArgumentTypes();
   virtual std::string getString();
protected:
  // Override!
  virtual std::string getOperationString();
};

/*******************************************
 * Operation for representing dashes       *
 *******************************************/
class OpFloatIf : public FloatOperation {
public:
  virtual Operation* clone() { return cloneOperation(this); }
  // Theese need to be overridden
   virtual std::vector<opType> getArgumentTypes();
   virtual float getFloat();
protected:
  // Override!
  virtual std::string getOperationString();
};

/**********************************************
 * Operation for representing turns           *
 **********************************************/
class OpPointIf : public PointOperation {
public:
  virtual Operation* clone() { return cloneOperation(this); }
  // Theese need to be overridden
   virtual std::vector<opType> getArgumentTypes();
   virtual Point getPoint();
protected:
  // Override!
  virtual std::string getOperationString();
};

RS_END_NAMESPACE

#endif
