/* -*- Mode: C++ -*-
 * $Id: CoverSpan.h,v 1.1 2001/07/12 12:56:20 andbo928 Exp $
 *
 * IDENTIFICATION
 *
 * Filename: CoverSpan.h
 * Unitname: Framework/view
 * $Revision: 1.1 $
 * Created by: Fredrik Heintz 2000-09-12
 * Last modified by $Author: andbo928 $ $Date: 2001/07/12 12:56:20 $
 *
 *
 * HISTORY
 *
 * $Log: CoverSpan.h,v $
 * Revision 1.1  2001/07/12 12:56:20  andbo928
 * Added CoverSpan.
 *
 * Revision 1.6  2001/06/05 20:33:53  mikbr212
 * Fixed doxygen-stubs for all classes
 *
 * Revision 1.5  2001/04/24 23:39:02  mikbr212
 * ?
 *
 * Revision 1.4  2001/04/24 19:12:28  mikbr212
 * added sticky
 *
 * Revision 1.3  2001/04/24 12:30:47  mikbr212
 * fixed
 *
 * Revision 1.2  2001/04/23 22:57:11  mikbr212
 * Killed and made a new skill. Not done yet
 *
 *
 */

/**
 * @file CoverSpan.h
 * Include file for the view class CoverSpan.
 *
 * @par Unit:
 *      Framework/view
 * $Revision: 1.1 $
 * $Author: andbo928 $
 * $Date: 2001/07/12 12:56:20 $
 */

#ifndef COVERSPAN_H
#define COVERSPAN_H

#include "Skill.h"

#include "view_constants.h"

#include "WorldStateView.h"
#include "PassTreeView.h"
#include "CommunicationView.h"

#include "MarkPosition.h"

#include <list>

RS_BEGIN_NAMESPACE

/**
 * @class CoverSpan CoverSpan.h
 * This class implements the mark player skill
 *
 *
 * @par Unit:
 *      Framework/skill
 * $Revision: 1.1 $
 * $Author: andbo928 $
 * $Date: 2001/07/12 12:56:20 $
 */

class CoverSpan : public MarkPosition {
public:
  CoverSpan();
  virtual ~CoverSpan();
  virtual Plan generatePlan();
  virtual FuzzyBool persistent();
  virtual FuzzyBool applicable();

protected:
  struct Span {
    double start;
    double end;
  };

  WorldStateView* worldStateView;
  ParameterView* parameterView;

  void CoverSpan::insertSpan(Span s, list<CoverSpan::Span>& spans);
  void calculateSpans(TVector threat, 
		      TVector& spanStart,
		      TVector& spanEnd);


};

RS_END_NAMESPACE

#endif // !COVERSPAN_H

