#include "Operation.h"

RS_BEGIN_NAMESPACE

Point g_OpPointArgs[16];
float g_OpFloatArgs[16];

//static int nConstructed = 0;

Operation::Operation()
{
  //  nConstructed++;
  arguments.clear();
}

Operation::Operation(Operation& o)
{
  //  cout << "Operation::Operation(Operation o)" << endl;
//    nConstructed++;
//    cout << nConstructed << "," << flush;

  arguments.clear();
  for(unsigned int i = 0; i < o.arguments.size(); i++)
    {
      arguments.insert(arguments.end(), o.arguments[i]->clone());
    }
}

Operation::~Operation()
{ 
//    nConstructed--;
//    cout << nConstructed << "," << flush;
  for(unsigned int i = 0; i < arguments.size(); i++)
    {
      delete arguments[i];
    }
  arguments.clear();
}

void Operation::setArguments(std::vector<Operation*> args)
{ 

  // Clone the new arguments before assignement
  // This is to handle, get/modify/set operations.
  // And self assignement.

  std::vector<Operation*> tmp;
  for(unsigned int i = 0; i < args.size(); i++) {
    tmp.insert(tmp.end(),args[i]->clone());
  }

  for(unsigned int i = 0; i < arguments.size(); i++)
    {
      delete arguments[i];
    }
  arguments.clear();

  arguments = tmp;
}


std::vector<opType> Operation::getArgumentTypes()
{
  vector<opType> res;
  res.clear();
  return res;
}

void Operation::setPointArg(int num, Point p)
{
  if(num >= 0 && num < 16)
    g_OpPointArgs[num] = p;
}

void Operation::setFloatArg(int num, float f)
{
  if(num >= 0 && num < 16)
    g_OpFloatArgs[num] = f;
}

Point Operation::getPointArg(int num)
{
  if(num >= 0 && num < 16)
    return g_OpPointArgs[num];
  return Point(0,0);
}

float Operation::getFloatArg(int num)
{
  if(num >= 0 && num < 16)
    return g_OpFloatArgs[num];
  return 0;
}

opType Operation::getReturnType()
{
  return opFloat;
}

float Operation::getFloat()
{
  return 0.0;
}

Point Operation::getPoint()
{
  return Point(0,0);
}

std::string Operation::getString()
{
  return "NULL";
}

std::string Operation::getOperationString()
{
  return "NOP";
}

std::string Operation::getDescription()
{
  std::string res = "(" + getOperationString();

  if(arguments.size() < getArgumentTypes().size())
    return res + "ERROR)";

  for(unsigned int i = 0; i < getArgumentTypes().size(); i++) {
    res += " " + arguments[i]->getDescription();
  }

  res += ")";
  return res;
}

void Operation::print()
{
  cout << "Operation: " << endl << getDescription() << endl << "Result: " << endl;
  switch(getReturnType()) {
  case opFloat:
    cout << getFloat();
    break;
  case opPoint:
    cout << getPoint();
    break;
  case opString:
    cout << getString();
    break;
  }
  cout << endl << "========================================" << endl;
}


/** Template for float returning only operations. */
opType FloatOperation::getReturnType()
{ 
  return opFloat;
}

//  float FloatOperation::getFloat()
//  {
//    return 0.0;
//  }

/** Template for point returning only operations. */
opType PointOperation::getReturnType()
{ 
  return opPoint;
}

//  Point PointOperation::getPoint()
//  {
//    return Point(0,0);
//  }

/** Template for string returning only operations. */
opType StringOperation::getReturnType()
{ 
  return opString;
}

//  std::string StringOperation::getString()
//  {
//    return "NULL";
//  }


RS_END_NAMESPACE









