#ifndef _OPERATION_H_
#define _OPERATION_H_
//#include <string>

#include "Skill.h"

#include "CoordVector.h"
#include "CoordPoint.h"
#include "view_constants.h"
#include "ParameterView.h"
#include "MarkerView.h"
#include "AgentView.h"
#include "BallView.h"
#include "rs_log.h"
#include "KickBallToSpeedVectorMulti.h"

RS_BEGIN_NAMESPACE

//#include "String.h"
#include "CoordPoint.h"

enum opType {
  opPoint,
  opFloat,
  opString
};

class Operation;

template<class operation>
Operation *cloneOperation(operation* tmp)
{
  return new operation(*tmp);
}

class Operation {
public:
  Operation();
  Operation(Operation& o);
  virtual ~Operation();
// {     arguments.clear();
//    }


  void setPointArg(int num, Point p);
  void setFloatArg(int num, float f);
  Point getPointArg(int num);
  float getFloatArg(int num);

  virtual opType getReturnType();
  
  std::vector<Operation*> getArguments() { return arguments; }
  void setArguments(std::vector<Operation*> args);
  
  virtual Operation* clone() {
    return cloneOperation(this);
  }
  
  // Override the appropriate ones.
  virtual std::vector<opType> getArgumentTypes();
  virtual float getFloat();
  virtual Point getPoint();
  virtual std::string getString();

  std::string getDescription();
  void print();
protected:
  // Override!
  virtual std::string getOperationString();
  std::vector<Operation*> arguments;
};


class FloatOperation : public Operation {
public:
  virtual opType getReturnType();
};

class PointOperation : public Operation {
public:
  virtual opType getReturnType();
};

class StringOperation : public Operation {
public:
  virtual opType getReturnType();
};

RS_END_NAMESPACE

#endif



