/* -*- Mode: C++ -*-
 * $Id: SiggeDribble.cc,v 1.3 2001/07/28 15:29:47 andbo928 Exp $
 *
 *
 * COPYRIGHT INFORMATION
 *
 * This file is part of RoboSoc created by Fredrik Heintz <frehe@ida.liu.se>
 * Copyright (C) 1999, 2000 Fredrik Heintz, Linkping University, Sweden
 *0
 * You are allowed to modify and use this code as long as you retain this
 * notice. If you make any changes or have any comments I would appreciate
 * it if you send me a message. For more information, please see
 * http://www.ida.liu.se/~frehe/RoboCup/RoboSoc/
 *
 *
 * IDENTIFICATION
 *
 * Filename: SiggeDribble.cc
 * Unitname: Framework/skill
 * $Revision: 1.3 $
 * Created by:Chris & Govert
 * Last modified by $Author: andbo928 $ $Date: 2001/07/28 15:29:47 $
 *
 *
 * HISTORY
 */

/**
 * @file SiggeDribble.cc
 * Implementation file for the skill class SiggeDribble.
 *
 * @par Unit:
 *      Framework/skill
 * $Revision: 1.3 $
 * $Author: andbo928 $
 * $Date: 2001/07/28 15:29:47 $
 */


#include "SiggeDribble.h"
#include "BallKickable.h"
#include "ViewManager.h"

RS_BEGIN_NAMESPACE

SiggeDribble::SiggeDribble()
  : Skill(),
    worldView(NULL)
{
  getView(worldView, WORLD_STATE_VIEW_ID);
} 


SiggeDribble::~SiggeDribble()
{
  viewManager->releaseView(WORLD_STATE_VIEW_ID);
}

//------------------------------------------------------------

Plan SiggeDribble::generatePlan()
{
  // I'm lazy right now.
  WorldState ws = worldView->getWorldState();

  TVector bToG = TVector(55, 0) - ws.getBall().getPosition();
  bToG.setLength(0.5);
  kickBall.setVector(bToG);
  return kickBall.generatePlan();
}


FuzzyBool SiggeDribble::persistent()
{
  return FALSE;
}


FuzzyBool SiggeDribble::applicable()
{
  if(kickBall.applicable());
    return TRUE;
  return FALSE;
}


RS_END_NAMESPACE
