/* -*- Mode: C++ -*-
 * $Id: TakeBall.h,v 1.1.1.1 2001/04/08 11:33:58 sigge Exp $
 *
 *
 * COPYRIGHT INFORMATION
 *
 * This file is part of RoboSoc created by Fredrik Heintz <frehe@ida.liu.se>
 * Copyright (C) 1999, 2000 Fredrik Heintz, Linkping University, Sweden
 *
 * You are allowed to modify and use this code as long as you retain this
 * notice. If you make any changes or have any comments I would appreciate
 * it if you send me a message. For more information, please see
 * http://www.ida.liu.se/~frehe/RoboCup/RoboSoc/
 *
 *
 * IDENTIFICATION
 *
 * Filename: TakeBall.h
 * Unitname: Framework/skill
 * $Revision: 1.1.1.1 $
 *
 * HISTORY
 * $Log: TakeBall.h,v $
 * Revision 1.1.1.1  2001/04/08 11:33:58  sigge
 * Imported sources
 *
 */

/**
 * @file TakeBall.h
 * Include file for the skill class TakeBall.
 *
 * @par Unit:
 *      Framework/skill
 * $Revision: 1.1.1.1 $
 * $Author: sigge $
 * $Date: 2001/04/08 11:33:58 $
 */


#ifndef TAKEBALL_H
#define TAKEBALL_H


#include "Skill.h"
#include "InterceptBallStamina.h"
#include "GotoBall.h"
#include "ParameterView.h"
#include "KickBallView.h"

RS_BEGIN_NAMESPACE


/**
 * @class TakeBall TakeBall.h
 * This class is a skill which encapsulates a plan.
 * 
 * A plan can be set to this skill
 * and then generatePlan will return that plan.
 *
 * <!--
 * @pre The preconditions for the skill are...
 * @post The postconditions for the skill are...
 * @invariant The class invariant is...
 *
 * @todo This needs to be done...
 * -->
 *
 * @par Unit:
 *      Framework/skill
 * $Revision: 1.1.1.1 $
 * $Author: sigge $
 * $Date: 2001/04/08 11:33:58 $
 */
class TakeBall : public Skill {
public:
  TakeBall();
  virtual ~TakeBall();

  virtual Plan generatePlan();

  virtual FuzzyBool persistent();
  virtual FuzzyBool applicable();

protected:
  InterceptBallStamina intercept;
  KickBallToSpeedVector kick;
  GotoBall go;
  
  ParameterView* parameterView;
  KickBallView* kickBallView;
};


RS_END_NAMESPACE


#endif // !TAKEBALL_H
