/* -*- Mode: C++ -*-
 * $Id: IntentionStub.cc,v 1.1 2001/06/19 14:11:43 mikbr212 Exp $
 *
 * IDENTIFICATION
 *
 * $Revision: 1.1 $
 * Created by: Mikael Brnnstrm, Andreas Bckert, Andreas Sigfridsson
 * Last modified by $Author: mikbr212 $ $Date: 2001/06/19 14:11:43 $
 *
 *
 * HISTORY
 *
 * $Log: IntentionStub.cc,v $
 * Revision 1.1  2001/06/19 14:11:43  mikbr212
 * Created
 *
 */

/**
 * @file IntentionStub.cc
 * Implementation file for the class IntentionStub.
 *
 * @par Unit:
 *      Framework
 * $Revision: 1.1 $
 * $Author: mikbr212 $
 * $Date: 2001/06/19 14:11:43 $
 */


#include "IntentionStub.h"

RS_BEGIN_NAMESPACE

/** Constructs an intention. 
 */
IntentionStub::IntentionStub()
  : Intention()
{
}

/** Destroys the intention. 
 */
IntentionStub::~IntentionStub() {
}

// Uncomment either chooseSkill or generatePlan
/* Generates a plan. 
 * Returns an empty plan.
 *
 Plan IntentionStub::generatePlan() {
 return Plan(); // Your plan
 }
*/

// Uncomment either chooseSkill or generatePlan
/* Chooses a skill. It works like a mini-decision maker.
 *
 Skill* IntentionStub::chooseSkill() {
 return NULL; // Your skill
 }
*/

/** Models a player. 
 * This intention simply calls plr.doNull().
 * @param plr the player to be modelled
 */
void IntentionStub::model(PlayerState& plr) {
  plr.doNull(); // Do nothing
}

/** Checks if the intention is applicable for a certain player. 
 * This intention is always applicable.
 */
FuzzyBool IntentionStub::applicable(const PlayerState& plr) {
  return TRUE; // Allways applicable.
}

/** Returns the persistence of this intention.
 * This intention is very persistent.
 * @return a float between zero (not persistent) and one (very persistent)
 */
float IntentionStub::getPersistence() const {
  return 1.0; // Very persistent
}

/** Returns the ID that identifies this (type of) intention.
 */
IntentionId IntentionStub::getID() const {
  return 0; // Add a line in "intention_constants.h" and return that.
}

RS_END_NAMESPACE

/* CONDITIONAL INCLUSION OF INLINE DEFINITIONS
 *
 * If the compiler or debugger does not understand the keyword inline then
 * include the inline definitions here, otherwise include them in the
 * declaration file.
 *
 * This is controlled by a flag called RS_USE_INLINE, which is usually
 * defined. It can be set by the user by giving the compiler an argument
 * usually -DRS_USE_INLINE (to define it) or -URS_USE_INLINE (to undefine it).
 */

#ifndef RS_USE_INLINE
#  include "IntentionStub.icc"
#endif







