/* -*- Mode: C++ -*-
 * $Id: TAngle.h,v 1.3 2001/06/05 20:33:53 mikbr212 Exp $
 *
 *
 * COPYRIGHT INFORMATION
 *
 * This file is part of RoboSoc created by Fredrik Heintz <frehe@ida.liu.se>
 * Copyright (C) 1999, 2000 Fredrik Heintz, Linkping University, Sweden
 *
 * You are allowed to modify and use this code as long as you retain this
 * notice. If you make any changes or have any comments I would appreciate
 * it if you send me a message. For more information, please see
 * http://www.ida.liu.se/~frehe/RoboCup/RoboSoc/
 *
 *
 * IDENTIFICATION
 *
 * Filename: TAngle.h
 * Unitname: Library
 * $Revision: 1.3 $
 * Created by: Fredrik Heintz 2000-08-29
 * Last modified by $Author: mikbr212 $ $Date: 2001/06/05 20:33:53 $
 *
 *
 * HISTORY
 *
 * $Log: TAngle.h,v $
 * Revision 1.3  2001/06/05 20:33:53  mikbr212
 * Fixed doxygen-stubs for all classes
 *
 * Revision 1.2  2001/04/15 12:17:50  andbo928
 * Fixed normalize() method.
 *
 * Revision 1.1  2001/04/15 12:12:28  andbo928
 * Added TAngle.
 *
 */

/**
 * @file TAngle.h
 * Definition file for the class TAngle.
 *
 * $Revision: 1.3 $
 * $Author: mikbr212 $
 * $Date: 2001/06/05 20:33:53 $
 */

#ifndef TANGLE_H
#define TANGLE_H

#include "library_compiler_directives.h"
#include "math_utils.h"

RS_BEGIN_NAMESPACE

/**
 * @class TAngle TAngle.h
 * Text...
 */

class TAngle {
 protected:
  double angle;
  void normalize();

 public:
  TAngle();
  TAngle(const double _angle);
  //  TAngle(const TVector& vec);

  TAngle operator+(const TAngle& other) const;
  TAngle operator-(const TAngle& other) const;

  TAngle operator+(const double other) const;
  TAngle operator-(const double other) const;
  TAngle operator*(const double other) const;
  TAngle operator/(const double other) const;

  operator double() const;

  static double degToRad(const double deg);
  static double radToDeg(const double rad);

  double getDeg() const;
  void setDeg(const double value);
  double getRad() const;
  void setRad(const double value);

};

RS_END_NAMESPACE


#ifdef RS_USE_INLINE
#  include "TAngle.icc"
#endif

#endif // !TANGLE_H
