/* -*- Mode: C++ -*-
 * $Id: Confidence.cc,v 1.1.1.1 2001/04/08 11:33:59 sigge Exp $
 *
 *
 * COPYRIGHT INFORMATION
 *
 * This file is part of RoboSoc created by Fredrik Heintz <frehe@ida.liu.se>
 * Copyright (C) 1999, 2000 Fredrik Heintz, Linkping University, Sweden
 *
 * You are allowed to modify and use this code as long as you retain this
 * notice. If you make any changes or have any comments I would appreciate
 * it if you send me a message. For more information, please see
 * http://www.ida.liu.se/~frehe/RoboCup/RoboSoc/
 *
 *
 * IDENTIFICATION
 *
 * Filename: Confidence.cc
 * Unitname: Library
 * $Revision: 1.1.1.1 $
 * Created by: Fredrik Heintz 1999-xx-xx
 * Last modified by $Author: sigge $ $Date: 2001/04/08 11:33:59 $
 *
 *
 * HISTORY
 *
 * $Log: Confidence.cc,v $
 * Revision 1.1.1.1  2001/04/08 11:33:59  sigge
 * Imported sources
 *
 * Revision 1.1  2000/09/01 01:24:45  frehe
 * Importet the current version of RoboSoc (soon to be v2.5.0)
 *
 *
 */

/**
 * @file Confidence.cc
 * Implementation of the class Confidence.
 *
 * @par Unit:
 *      Library
 * $Revision: 1.1.1.1 $
 * $Author: sigge $
 * $Date: 2001/04/08 11:33:59 $
 */


#include "Confidence.h"


RS_BEGIN_NAMESPACE




Confidence::Confidence(const Float32 c)
  : confidence(minMax(0.0F, c, 1.0F))
{
}

Confidence::Confidence(const Confidence& c)
  : confidence(c.confidence)
{
}

const std::string toString(const Confidence& c)
{
#ifdef CONFIDENCE_HEAD
  return CONFIDENCE_HEAD + "(" + toString(c.getConfidence()) + ")";
#else
  return toString(c.getConfidence());
#endif
}


RS_END_NAMESPACE
